----------------------------------------------------------------------------------
-- Company: 
-- Engineer: 
-- 
-- Create Date:    23:25:13 04/23/2008 
-- Design Name: 
-- Module Name:    Stav_aut - Behavioral 
-- Project Name: 
-- Target Devices: 
-- Tool versions: 
-- Description: 
--
-- Dependencies: 
--
-- Revision: 
-- Revision 0.01 - File Created
-- Additional Comments: 
--
----------------------------------------------------------------------------------
library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.STD_LOGIC_ARITH.ALL;
use IEEE.STD_LOGIC_UNSIGNED.ALL;

---- Uncomment the following library declaration if instantiating
---- any Xilinx primitives in this code.
--library UNISIM;
--use UNISIM.VComponents.all;

entity Stav_aut is
 Port (
	bt : in  STD_LOGIC;
	clk : in  STD_LOGIC;
	areset : in  STD_LOGIC;
	start_out : out  STD_LOGIC;
	stop_out : out  STD_LOGIC;
	reset_out : out  STD_LOGIC);
end Stav_aut;

architecture Behavioral of Stav_aut is

type state_type is (reset1, start0, start1, stop0, stop1, reset0);
attribute ENUM_ENCODING: STRING;
attribute enum_encoding of state_type: type is "000 101 100 011 010 001";
signal current_state,next_state : state_type;

begin

registers: process (clk, areset)
	begin
	if areset = '1' then current_state <= reset1;
		elsif clk = '1' and clk'event then
		current_state <= next_state;
		end if;
end process;

combinational : process(current_state, bt)
	begin
	reset_out <= '1';
	start_out <= '0';
	stop_out <= '0';
next_state <= reset1;
	

	case current_state is
		when reset1 =>
		reset_out <= '1'; start_out <= '0';
			if bt = '1' then
				next_state <= start0;
			else
				next_state <= reset1;
			end if;

		when start0 =>
		start_out <= '1'; reset_out <= '0';
			if bt = '1' then
				next_state <= start0;
			else
				next_state <= start1;
			end if;

		when start1 =>
		start_out <= '1'; reset_out <= '0';
			if bt = '1' then
				next_state <= stop0;
			else
				next_state <= start1;
			end if;
			
		when stop0 =>
		stop_out <= '1'; start_out <= '0'; reset_out <= '0';
			if bt = '1' then
				next_state <= stop0;
			else
				next_state <= stop1;
			end if;

		when stop1 =>
		stop_out <= '1'; start_out <= '0'; reset_out <= '0';
			if bt = '1' then
				next_state <= reset0;
			else
				next_state <= stop1;
			end if;

		when reset0 =>
		reset_out <= '1'; start_out <= '0';
			if bt = '1' then
				next_state <= reset0;
			else
				next_state <= reset1;
			end if;

	end case;
end process;

end Behavioral;


